
# Contribution Guidelines

Thank you for considering contributing to the Narrowlink project! We welcome all contributions and value the effort you put into improving our project. To ensure a smooth and collaborative experience, please review the following guidelines before contributing.

## Code of Conduct

Before contributing, please familiarize yourself with our [Code of Conduct](CODE_OF_CONDUCT.md). We expect all contributors to adhere to these guidelines and create a welcoming and respectful environment for everyone.

## Security

**Please Note:** If you discover any security-related issues or vulnerabilities in Narrowlink, we kindly ask you to report them directly to our security team at [security@narrowlink.com](mailto:security@narrowlink.com). Do not create a public GitHub issue for security-related concerns. We take security seriously and will respond to your report promptly. Your cooperation is crucial in ensuring the security and integrity of the project.

For more information on how we handle security, please refer to our [Security Policy](SECURITY.md).

## How to Contribute

1.  **Fork the Repository:** Fork the Narrowlink repository to your GitHub account.
    
2.  **Create a Branch:** Create a new branch in your forked repository for your contributions. Choose a descriptive and concise name for the branch.
    
3.  **Work on Your Changes:** Make the necessary changes and improvements in your branch. Follow the coding conventions and guidelines of the project.
    
4.  **Commit Your Changes:** Commit your changes with clear and descriptive commit messages. If your contribution addresses an open issue, reference it in the commit message.
    
5.  **Pull Request:** Once you are satisfied with your changes, open a pull request from your branch to the main repository's `main` branch. Provide a detailed description of your changes and the problem it solves. The maintainers will review your contribution, and feedback may be given if needed.
    
6.  **Review and Merge:** The maintainers will review your pull request, and if everything is in order, they will merge it into the main repository. If changes are requested, address the feedback accordingly.
    

## Bug Reports and Feature Requests

If you encounter a bug or have an idea for a new feature, please submit a detailed issue in the GitHub repository. Use the issue templates provided to ensure you include all the necessary information.

## Code Guidelines

-   Follow the coding conventions and styles used in the project.
-   Write clear and concise code with appropriate comments where necessary.
-   Make sure your changes do not break existing functionality and tests.

## Testing

When adding new features or making changes, please include relevant test cases to ensure the stability and reliability of the codebase. Existing tests should not fail because of your contributions.

## Documentation

Help improve the project's documentation by fixing errors, adding explanations, and providing clear examples. Well-documented code and features greatly contribute to the project's usability.

## Licensing

By contributing to Narrowlink, you agree that your contributions will be licensed under the same licenses as the files you are modifying. The `agent`, `client`, `network`, `token-generator` and `types` components use the MPL v2.0 license, while the `gateway` component uses the AGPL-3.0 license.

If your contributions include new files, they will be subject to the same license as the component they belong to.


## Contact

If you have any questions or need assistance with your contributions, feel free to reach out to us at [opensource@narrowlink.com](mailto:opensource@narrowlink.com). We appreciate your interest in contributing to the Narrowlink project!
